/********************************************************************************************
 *     LEGAL DISCLAIMER 
 *
 *     (Header of MediaTek Software/Firmware Release or Documentation)
 *
 *     BY OPENING OR USING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES 
 *     THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE") RECEIVED 
 *     FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON AN "AS-IS" BASIS 
 *     ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES, EXPRESS OR IMPLIED, 
 *     INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR 
 *     A PARTICULAR PURPOSE OR NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY 
 *     WHATSOEVER WITH RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, 
 *     INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK 
 *     ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
 *     NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S SPECIFICATION 
 *     OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
 *     
 *     BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE LIABILITY WITH 
 *     RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, 
 *     TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE 
 *     FEES OR SERVICE CHARGE PAID BY BUYER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
 *     
 *     THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE WITH THE LAWS 
 *     OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF LAWS PRINCIPLES.  
 ************************************************************************************************/

#ifndef __DRV_IR_H__
#define __DRV_IR_H__

#define KEY_GROUP_DIGIT         ((UINT32) 0x00010000)
#define KEY_GROUP_ALPHA         ((UINT32) 0x00020000)
#define KEY_GROUP_CURSOR        ((UINT32) 0x00030000)
#define KEY_GROUP_SEL_CTRL      ((UINT32) 0x00040000)
#define KEY_GROUP_PRG_CTRL      ((UINT32) 0x00050000)
#define KEY_GROUP_AUD_CTRL      ((UINT32) 0x00060000)
#define KEY_GROUP_TTX_CTRL      ((UINT32) 0x00070000)
#define KEY_GROUP_FCT_CTRL      ((UINT32) 0x00080000)
#define KEY_GROUP_STRM_CTRL     ((UINT32) 0x00090000)
#define KEY_GROUP_DVD_CTRL      ((UINT32) 0x000a0000)
#define KEY_GROUP_USER_DEF      ((UINT32) 0x000b0000)
#define KEY_GROUP_MAX           ((UINT32) 0x000c0000)

#define BTN_DIGIT_0             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '0')))
#define BTN_DIGIT_1             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '1')))
#define BTN_DIGIT_2             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '2')))
#define BTN_DIGIT_3             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '3')))
#define BTN_DIGIT_4             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '4')))
#define BTN_DIGIT_5             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '5')))
#define BTN_DIGIT_6             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '6')))
#define BTN_DIGIT_7             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '7')))
#define BTN_DIGIT_8             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '8')))
#define BTN_DIGIT_9             ((UINT32)(KEY_GROUP_DIGIT | ((UINT32) '9')))
#define BTN_DIGIT_PLUS_5        ((UINT32)(KEY_GROUP_DIGIT | 0x0000f000))
#define BTN_DIGIT_PLUS_10       ((UINT32)(KEY_GROUP_DIGIT | 0x0000f001))
#define BTN_DIGIT_PLUS_20       ((UINT32)(KEY_GROUP_DIGIT | 0x0000f002))
#define BTN_DIGIT_PLUS_100      ((UINT32)(KEY_GROUP_DIGIT | 0x0000f003))
#define BTN_DIGIT_DOT           ((UINT32)(KEY_GROUP_DIGIT | 0x0000f004))

#define BTN_CURSOR_LEFT         ((UINT32)(KEY_GROUP_CURSOR | 0x0000f000))
#define BTN_CURSOR_RIGHT        ((UINT32)(KEY_GROUP_CURSOR | 0x0000f001))
#define BTN_CURSOR_UP           ((UINT32)(KEY_GROUP_CURSOR | 0x0000f002))
#define BTN_CURSOR_DOWN         ((UINT32)(KEY_GROUP_CURSOR | 0x0000f003))

#define BTN_SELECT              ((UINT32)(KEY_GROUP_SEL_CTRL | 0x0000f000))
#define BTN_EXIT                ((UINT32)(KEY_GROUP_SEL_CTRL | 0x0000f001))
#define BTN_CLEAR               ((UINT32)(KEY_GROUP_SEL_CTRL | 0x0000f002))

#define BTN_PRG_UP              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f000))
#define BTN_PRG_DOWN            ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f001))
#define BTN_PREV_PRG            ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f002))
#define BTN_CH_LIST             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f003))
#define BTN_FAV_CH              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f004))
#define BTN_FAV_CH_UP           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f005))
#define BTN_FAV_CH_DOWN         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f006))
#define BTN_FAVORITE            ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f007))
#define BTN_PIP                 ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f008))
#define BTN_PIP_CH_UP           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f009))
#define BTN_PIP_CH_DOWN         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f00a))
#define BTN_PIP_SIZE            ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f00b))
#define BTN_PIP_POS             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f00c))
#define BTN_PIP_INPUT_SRC       ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f00d))
#define BTN_POP                 ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f00e))
#define BTN_PIP_POP             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f00f))
#define BTN_SWAP                ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f010))
#define BTN_FREEZE              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f011))
#define BTN_ZOOM                ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f012))
#define BTN_ZOOM_IN             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f013))
#define BTN_ZOOM_OUT            ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f014))
#define BTN_ASPECT              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f015))
#define BTN_P_EFFECT            ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f016))
#define BTN_PRG_INFO            ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f017))
#define BTN_PRG_DETAIL          ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f018))
#define BTN_CC                  ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f019))
#define BTN_ADD_ERASE           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f01a))
#define BTN_SLEEP               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f01b))
#define BTN_TIMER               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f01c))
#define BTN_AUTO_SYNC           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f01d))
#define BTN_INPUT_SRC           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f01e))
#define BTN_TV                  ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f01f))
#define BTN_TV_ANA              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f020))
#define BTN_TV_DIG              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f021))
#define BTN_TUNER_TER_ANA       ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f022))
#define BTN_TUNER_CAB_ANA       ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f023))
#define BTN_TUNER_SAT_ANA       ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f024))
#define BTN_TUNER_TER_DIG       ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f025))
#define BTN_TUNER_CAB_DIG       ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f026))
#define BTN_TUNER_SAT_DIG       ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f027))
#define BTN_COMPOSITE           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f028))
#define BTN_COMPOSITE_1         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f029))
#define BTN_COMPOSITE_2         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f02a))
#define BTN_COMPOSITE_3         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f02b))
#define BTN_COMPOSITE_4         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f02c))
#define BTN_S_VIDEO             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f02d))
#define BTN_S_VIDEO_1           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f02e))
#define BTN_S_VIDEO_2           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f02f))
#define BTN_S_VIDEO_3           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f030))
#define BTN_S_VIDEO_4           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f031))
#define BTN_COMPONENT           ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f032))
#define BTN_COMPONENT_1         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f033))
#define BTN_COMPONENT_2         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f034))
#define BTN_COMPONENT_3         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f035))
#define BTN_COMPONENT_4         ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f036))
#define BTN_VGA                 ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f037))
#define BTN_DVI                 ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f038))
#define BTN_DVI_1               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f039))
#define BTN_DVI_2               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f03a))
#define BTN_DVI_3               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f03b))
#define BTN_DVI_4               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f03c))
#define BTN_HDMI                ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f03d))
#define BTN_HDMI_1              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f03e))
#define BTN_HDMI_2              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f03f))
#define BTN_HDMI_3              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f040))
#define BTN_HDMI_4              ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f041))
#define BTN_SCART               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f042))
#define BTN_SCART_1             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f043))
#define BTN_SCART_2             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f044))
#define BTN_SCART_3             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f045))
#define BTN_SCART_4             ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f046))
#define BTN_DVD                 ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f047))
#define BTN_ILINK               ((UINT32)(KEY_GROUP_PRG_CTRL | 0x0000f048))

#define BTN_VOL_UP              ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f000))
#define BTN_VOL_DOWN            ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f001))
#define BTN_MUTE                ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f002))
#define BTN_MTS                 ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f003))
#define BTN_AUDIO               ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f004))
#define BTN_MTS_AUDIO           ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f005))
#define BTN_PIP_AUDIO           ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f006))
#define BTN_S_EFFECT            ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f007))
#define BTN_SPK_LEV             ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f008))
#define BTN_OPTICAL             ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f009))
#define BTN_MIC_UP              ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f00a))
#define BTN_MIC_DOWN            ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f00b))
#define BTN_FP_VOL_UP           ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f00c))
#define BTN_FP_VOL_DOWN         ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f00d))
#define BTN_OPTICAL_CEC         ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f00e))
#define BTN_AUX_CEC             ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f00f))
#define BTN_AM                  ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f010))
#define BTN_FM                  ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f011))
#define BTN_AUDIO_SYNC          ((UINT32)(KEY_GROUP_AUD_CTRL | 0x0000f012))


#define BTN_TTX                 ((UINT32)(KEY_GROUP_TTX_CTRL | 0x0000f000))
#define BTN_INDEX               ((UINT32)(KEY_GROUP_TTX_CTRL | 0x0000f001))
#define BTN_REVEAL              ((UINT32)(KEY_GROUP_TTX_CTRL | 0x0000f002))
#define BTN_MIX                 ((UINT32)(KEY_GROUP_TTX_CTRL | 0x0000f003))
#define BTN_SUBPAGE             ((UINT32)(KEY_GROUP_TTX_CTRL | 0x0000f004))
#define BTN_SIZE                ((UINT32)(KEY_GROUP_TTX_CTRL | 0x0000f005))
#define BTN_WIDE_MODE           ((UINT32)(KEY_GROUP_TTX_CTRL | 0x0000f006))

#define BTN_POWER               ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f000))
#define BTN_MENU                ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f001))
#define BTN_EPG                 ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f002))
#define BTN_MEM_CARD            ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f003))
#define BTN_TEXT                ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f004))
#define BTN_POWER_ON            ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f005))
#define BTN_POWER_OFF           ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f006))
#define BTN_MODE                ((UINT32)(KEY_GROUP_FCT_CTRL | 0x0000f009))



#define BTN_PLAY                ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f000))
#define BTN_PAUSE               ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f001))
#define BTN_STOP                ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f002))
#define BTN_RESUME              ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f003))
#define BTN_RECORD              ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f004))
#define BTN_NEXT                ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f005))
#define BTN_PREV                ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f006))
#define BTN_FF                  ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f007))
#define BTN_FR                  ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f008))
#define BTN_SF                  ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f009))
#define BTN_SR                  ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f00a))
#define BTN_STEPF               ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f00b))
#define BTN_STEPR               ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f00c))
#define BTN_PLAY_PAUSE          ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f00d))
#define BTN_PAUSE_STEP          ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f00e))
#define BTN_STOP_RESUME         ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f00f))
#define BTN_PLAY_ENTER          ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f010))
#define BTN_FP_NEXT             ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f011))
#define BTN_FP_PREV             ((UINT32)(KEY_GROUP_STRM_CTRL | 0x0000f012))



#define BTN_EJECT               ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f000))
#define BTN_TITLE_MENU          ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f001))
#define BTN_ROOT_MENU           ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f002))
#define BTN_GOTO                ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f003))
#define BTN_MARK                ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f004))
#define BTN_DIGEST              ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f005))
#define BTN_PROGRAM             ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f006))
#define BTN_VRMT                ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f007))
#define BTN_PBC                 ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f008))
#define BTN_REPEAT              ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f009))
#define BTN_REPEAT_A            ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f00a))
#define BTN_REPEAT_B            ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f00b))
#define BTN_REPEAT_A_B          ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f00c))
#define BTN_SUB_TITLE           ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f00d))
#define BTN_ANGLE               ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f00e))
#define BTN_DISPLAY             ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f00f))
#define BTN_RANDOM              ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f010))
#define BTN_PAL_NTSC            ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f011))
#define BTN_SURROUND            ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f012))
#define BTN_EQUALIZER           ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f013))
#define BTN_HOME_DLIST          ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f014))
#define BTN_NEXT_DLIST          ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f015))
#define BTN_PREV_DLIST          ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f016))
#define BTN_KARAOKE             ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f017))
#define BTN_AUD_KEY_PLUS        ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f018))
#define BTN_AUD_KEY_MINUS       ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f019))
#define BTN_AUD_KEY_RESUME      ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f01a))
#define BTN_ECHO_PLUS           ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f01b))
#define BTN_ECHO_MINUS          ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f01c))
#define BTN_VOCAL_ASSIST        ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f01d))
#define BTN_MENU_PBC            ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f01e))
#define BTN_TITLE_PBC           ((UINT32)(KEY_GROUP_DVD_CTRL | 0x0000f01f))

#define BTN_RED                 ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f000))
#define BTN_GREEN               ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f001))
#define BTN_YELLOW              ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f002))
#define BTN_BLUE                ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f003))
#define BTN_FACTORY_MODE_1      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f004))
#define BTN_FACTORY_MODE_2      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f005))
#define BTN_FACTORY_MODE_3      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f006))
#define BTN_FACTORY_MODE_4      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f007))
#define BTN_FACTORY_MODE_5      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f008))
#define BTN_FACTORY_MODE_6      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f009))
#define BTN_FACTORY_MODE_7      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f00a))
#define BTN_FACTORY_MODE_8      ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f00b))
#define BTN_FUNCTION_1          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f00c))
#define BTN_FUNCTION_2          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f00d))
#define BTN_FUNCTION_3          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f00e))
#define BTN_FUNCTION_4          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f00f))
#define BTN_FUNCTION_5          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f010))
#define BTN_FUNCTION_6          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f011))
#define BTN_FUNCTION_7          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f012))
#define BTN_FUNCTION_8          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f013))
#define BTN_FUNCTION_9          ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f014))
#define BTN_FUNCTION_10         ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f015))
#define BTN_FUNCTION_11         ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f016))
#define BTN_FUNCTION_12         ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f017))
#define BTN_CUSTOM_1            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f018))
#define BTN_CUSTOM_2            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f019))
#define BTN_CUSTOM_3            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f01a))
#define BTN_CUSTOM_4            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f01b))
#define BTN_CUSTOM_5            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f01c))
#define BTN_CUSTOM_6            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f01d))
#define BTN_CUSTOM_7            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f01e))
#define BTN_CUSTOM_8            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f01f))
#define BTN_CUSTOM_9            ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f020))
#define BTN_CUSTOM_10           ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f021))
#define BTN_CUSTOM_11           ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f022))
#define BTN_CUSTOM_12           ((UINT32)(KEY_GROUP_USER_DEF | 0x0000f023))

#define BTN_INVALID             ((UINT32)(KEY_GROUP_MAX | 0x0000f000))
/***************************************************************************/
#define BTN_NONE                ((UINT32) 0xffffffff)
#define BTN_NO_DEF              ((UINT32) 0xfffffffe)

#define BTN_KEY_REPEAT              ((UINT32) 0xfffffffd)
//modify end

/******************************************************************************
* u4Info:
*   Bit 31~24 is the value of the sampling counter in the 3rd pulse.
*   Bit 23~16 is the value of the sampling counter in the 2nd pulse.
*   Bit 15~08 is the value of the sampling counter in the 1st pulse.
*   Bit 05~00 is the bit count of this IR command.
******************************************************************************/
#define INFO_TO_BITCNT(u4Info)      ((u4Info & IRRX_CH_BITCNT_MASK)    >> IRRX_CH_BITCNT_BITSFT)
#define INFO_TO_1STPULSE(u4Info)    ((u4Info & IRRX_CH_1ST_PULSE_MASK) >> IRRX_CH_1ST_PULSE_BITSFT)
#define INFO_TO_2NDPULSE(u4Info)    ((u4Info & IRRX_CH_2ND_PULSE_MASK) >> IRRX_CH_2ND_PULSE_BITSFT)
#define INFO_TO_3RDPULSE(u4Info)    ((u4Info & IRRX_CH_3RD_PULSE_MASK) >> IRRX_CH_3RD_PULSE_BITSFT)


#endif /* __DRV_IR_H__ */

