/********************************************************************************************
 *     LEGAL DISCLAIMER 
 *
 *     (Header of MediaTek Software/Firmware Release or Documentation)
 *
 *     BY OPENING OR USING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES 
 *     THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE") RECEIVED 
 *     FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON AN "AS-IS" BASIS 
 *     ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES, EXPRESS OR IMPLIED, 
 *     INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR 
 *     A PARTICULAR PURPOSE OR NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY 
 *     WHATSOEVER WITH RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, 
 *     INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK 
 *     ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
 *     NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S SPECIFICATION 
 *     OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
 *     
 *     BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE LIABILITY WITH 
 *     RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, 
 *     TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE 
 *     FEES OR SERVICE CHARGE PAID BY BUYER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
 *     
 *     THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE WITH THE LAWS 
 *     OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF LAWS PRINCIPLES.  
 ************************************************************************************************/
/******************************************************************************
* [File]			NFI.h
* [Version]			v1.0
* [Revision Date]	2007-08-02
* [Author]			Meng-Chang Liu, MC_Liu@mtk.com.tw, 26615, 2007-08-02
* [Description]
*	MT8520 Download Agent NFI include file
* [Copyright]
*	Copyright (C) 2007 MediaTek Incorporation. All Rights Reserved.
******************************************************************************/
#ifndef _NFI3_H
#define _NFI3_H
#include <chip_ver.h>

#define NFI_WRITE32(u2Reg, u4Val)  \
          *(volatile UINT32 *)(u2Reg) = (u4Val)

#define NFI_READ32(u2Reg)  \
          *(volatile UINT32 *)(u2Reg)

#define NFI_SETBIT(reg, dBit)        NFI_WRITE32(reg, NFI_READ32(reg) | (dBit))
#define NFI_CLRBIT(reg, dBit)        NFI_WRITE32(reg, NFI_READ32(reg) & (~(dBit)))

#define NFI_CLK_SEL       ((volatile UINT32 *)(0xF0000000+0x70))
	#define PDN_NFI 0x00080000
	#define NFI_CLK_27 0x0
	#define NFI_CLK_198 0x00050000
	#define NFI_CLK_233 0x00040000
	#define NFI_CLK NFI_CLK_198
#define NFI_CLK_ENABLE      ((volatile UINT32 *)(0xF0000000+0x300))
#define NFI_CLK_RESET      ((volatile UINT32 *)(0xF0000000+0x310))

#define PAD_CFG_0           ((volatile UINT32 *)(0xF0000000+0xC0))
    #define NFI_SEL             (0x1 << 30)
#define PAD_CTRL_16 ((volatile UINT32 *)(0xF0000000+0x140))
	#define NFI_NFALE_RDSEL_MASK            0xFC000000 /* bit[31:26] */
    #define NFI_NFALE_RDSEL_3_3V            0x30000000
    #define NFI_NFALE_TDSEL_MASK            0x03C00000 /* bit[25:22] */
    #define NFI_NFALE_TDSEL_SET             0x02800000
    #define NFI_NFRBN_RDSEL_MASK            0x0000FC00 /* bit[15:10] */
    #define NFI_NFRBN_RDSEL_3_3V            0x00003000
    #define NFI_NFRBN_TDSEL_MASK            0x000003C0 /* bit[9:6] */
    #define NFI_NFRBN_TDSEL_SET             0x00000280
    #define NFI_NFRBN_PD                    (0x1 << 3)
    #define NFI_NFRBN_PU                    (0x1 << 2)
#define PAD_CTRL_14             ((volatile UINT32 *)(0xF0000000+0x138))
    #define NFI_NFCEN_RDSEL_MASK            0xFC000000 /* bit[31:26] */
    #define NFI_NFCEN_RDSEL_3_3V            0x30000000
    #define NFI_NFCEN_TDSEL_MASK            0x03C00000 /* bit[25:22] */
    #define NFI_NFCEN_TDSEL_SET             0x02800000
    #define NFI_NFCEN_PD                    (0x1 << 19)
    #define NFI_NFCEN_PU                    (0x1 << 18)
#define PAD_CTRL_15             ((volatile UINT32 *)(0xF0000000+0x13C))
    #define NFI_NFWEN_RDSEL_MASK            0xFC000000 /* bit[31:26] */
    #define NFI_NFWEN_RDSEL_3_3V            0x30000000
    #define NFI_NFWEN_TDSEL_MASK            0x03C00000 /* bit[25:22] */
    #define NFI_NFWEN_TDSEL_SET             0x02800000
    #define NFI_NFREN_RDSEL_MASK            0x0000FC00 /* bit[15:10] */
    #define NFI_NFREN_RDSEL_3_3V            0x00003000
    #define NFI_NFREN_TDSEL_MASK            0x000003C0 /* bit[9:6] */
    #define NFI_NFREN_TDSEL_SET             0x00000280
#define PAD_CTRL_17             ((volatile UINT32 *)(0xF0000000+0x144))
    #define NFI_NFCLE_RDSEL_MASK            0x0000FC00 /* bit[15:10] */
    #define NFI_NFCLE_RDSEL_3_3V            0x00003000
    #define NFI_NFCLE_TDSEL_MASK            0x000003C0 /* bit[9:6] */
    #define NFI_NFCLE_TDSEL_SET             0x00000280
#define PAD_CTRL_18             ((volatile UINT32 *)(0xF0000000+0x148))
    #define NFI_NFD0_RDSEL_MASK             0xFC000000 /* bit[31:26] */
    #define NFI_NFD0_RDSEL_3_3V             0x30000000
    #define NFI_NFD0_TDSEL_MASK             0x03C00000 /* bit[25:22] */
    #define NFI_NFD0_TDSEL_SET              0x02800000
#define PAD_CTRL_19             ((volatile UINT32 *)(0xF0000000+0x14C))
    #define NFI_NFD2_RDSEL_MASK             0xFC000000 /* bit[31:26] */
    #define NFI_NFD2_RDSEL_3_3V             0x30000000
    #define NFI_NFD2_TDSEL_MASK             0x03C00000 /* bit[25:22] */
    #define NFI_NFD2_TDSEL_SET              0x02800000
    #define NFI_NFD1_RDSEL_MASK             0x0000FC00 /* bit[15:10] */
    #define NFI_NFD1_RDSEL_3_3V             0x00003000
    #define NFI_NFD1_TDSEL_MASK             0x000003C0 /* bit[9:6] */
    #define NFI_NFD1_TDSEL_SET              0x00000280
#define PAD_CTRL_20             ((volatile UINT32 *)(0xF0000000+0x150))
    #define NFI_NFD4_RDSEL_MASK             0xFC000000 /* bit[31:26] */
    #define NFI_NFD4_RDSEL_3_3V             0x30000000
    #define NFI_NFD4_TDSEL_MASK             0x03C00000 /* bit[25:22] */
    #define NFI_NFD4_TDSEL_SET              0x02800000
    #define NFI_NFD3_RDSEL_MASK             0x0000FC00 /* bit[15:10] */
    #define NFI_NFD3_RDSEL_3_3V             0x00003000
    #define NFI_NFD3_TDSEL_MASK             0x000003C0 /* bit[9:6] */
    #define NFI_NFD3_TDSEL_SET              0x00000280
#define PAD_DUTY_7              ((volatile UINT32 *)(0xF0000000+0x2DC))
    #define NFI_NFD6_RDSEL_MASK             0xFC000000 /* bit[31:26] */
    #define NFI_NFD6_RDSEL_3_3V             0x30000000
    #define NFI_NFD6_TDSEL_MASK             0x03C00000 /* bit[25:22] */
    #define NFI_NFD6_TDSEL_SET             0x02800000
    #define NFI_NFD5_RDSEL_MASK             0x0000FC00 /* bit[15:10] */
    #define NFI_NFD5_RDSEL_3_3V             0x00003000
    #define NFI_NFD5_TDSEL_MASK             0x000003C0 /* bit[9:6] */
    #define NFI_NFD5_TDSEL_SET             0x00000280
    #define NFI_NFD6_DRV_MASK               (0x3 << 16)
    #define NFI_NFD6_PU                     (0x1 << 18)
    #define NFI_NFD6_PD                     (0x1 << 19)
#define PAD_DUTY_8              ((volatile UINT32 *)(0xF0000000+0x2E0))
    #define NFI_NFD8_RDSEL_MASK             0xFC000000 /* bit[31:26] */
    #define NFI_NFD8_RDSEL_3_3V             0x30000000
    #define NFI_NFD8_TDSEL_MASK             0x03C00000 /* bit[25:22] */
    #define NFI_NFD8_TDSEL_SET              0x02800000
    #define NFI_NFD7_RDSEL_MASK             0x0000FC00 /* bit[15:10] */
    #define NFI_NFD7_RDSEL_3_3V             0x00003000
    #define NFI_NFD7_TDSEL_MASK             0x000003C0 /* bit[9:6] */
    #define NFI_NFD7_TDSEL_SET              0x00000280

#define NFI_BASE_ADDR    (0xF001D000) 
 
#define NFI_CNFG    ((volatile UINT16 *)(NFI_BASE_ADDR+0x0000))
    #define CNFG_DMA             (0x0001)  // 0: PIO; 1: DMA
    #define CNFG_READ_EN         (0x0002)  // 0: Write; 1: Read  
    #define CNFG_DMA_BURST_EN    (0x0004)    
    #define CNFG_RAN_SEC_EN      (0x0010)  // 0: Randomizer seed for each page; 1: each sector
    #define CNFG_RAN_SEL         (0x0020)  // 1: SAMSANG; 0: TOSHIBA
    #define CNFG_BYTE_RW         (0x0040)
    #define CNFG_CRC_EN          (0x0080)
    #define CNFG_HW_ECC_EN       (0x0100)    
    #define CNFG_AUTO_FMT_EN     (0x0200)
    #define CNFG_OP_IDLE         (0x0000)
    #define CNFG_OP_READ         (0x1000)
    #define CNFG_OP_SRD          (0x2000)
    #define CNFG_OP_PRGM         (0x3000)
    #define CNFG_OP_ERASE        (0x4000)
    #define CNFG_OP_RESET        (0x5000)
    #define CNFG_OP_CUST         (0x6000)
    #define CNFG_OP_MASK         (0x7000)
    
#define NFI_PAGEFMT    ((volatile UINT16 *)(NFI_BASE_ADDR+0x0004))
    #define PAGEFMT_512_2K       (0x0000)  // page size is 512B if sel_sec_size is 1(512B), otherwise page size is 2KB.
    #define PAGEFMT_2K_4K        (0x0001)  // page size is 2KB if sel_sec_size is 1(512B), otherwise page size is 4KB.
    #define PAGEFMT_4K_8K        (0x0002)  // page size is 4KB if sel_sec_size is 1(512B), otherwise page size is 8KB.
    #define PAGEFMT_RESV_16K     (0x0003)  // Reserved if sel_sec_size is 1(512B), otherwise page size is 16KB.
    #define PAGEFMT_SECTOR_SIZE  (0x0004)  // 1: sector size 512B, 0: sector size 1024B(1KB).
    #define PAGEFMT_16BITS_IO_EN (0x0008)  // 16bits IO bus interface enable.
    // SPARE_SIZE represents the spare size for each sector; if sel_sec_size is 0(1KB), spare size will be doubled. 
    #define PAGEFMT_SPARE_16_32  (0x0000)
    #define PAGEFMT_SPARE_26_52  (0x0010)
    #define PAGEFMT_SPARE_27_54  (0x0020)
    #define PAGEFMT_SPARE_28_56  (0x0030)
    #define PAGEFMT_SPARE_32_64  (0x0040)
    #define PAGEFMT_SPARE_36_72  (0x0050)
    #define PAGEFMT_SPARE_40_80  (0x0060)
    #define PAGEFMT_SPARE_44_88  (0x0070)
    #define PAGEFMT_SPARE_48_96  (0x0080)
    #define PAGEFMT_SPARE_49_98  (0x0090)
    #define PAGEFMT_SPARE_50_100 (0x00A0)
    #define PAGEFMT_SPARE_51_102 (0x00B0)
    #define PAGEFMT_SPARE_52_104 (0x00C0)
    #define PAGEFMT_SPARE_62_124 (0x00D0)
    #define PAGEFMT_SPARE_63_126 (0x00E0)
    #define PAGEFMT_SPARE_64_128 (0x00F0)
    // FDM_NUM: The FDM data number for each spare area. (The valid number of bytes are from 0 to 8)
    #define PAGEFMT_FDM_MASK     (0x0F)
    #define PAGEFMT_FDM_SHIFT    (8)
        #define PAGEFMT_FDM_NUM(x)       (((UINT16)(x) &PAGEFMT_FDM_MASK) <<PAGEFMT_FDM_SHIFT)    
    // FDM_ECC_NUM: The number of each FDM data for HW ECC protertion. (The valid number of bytes are from 0 to 8)
    #define PAGEFMT_FDM_ECC_MASK  (0x0F)
    #define PAGEFMT_FDM_ECC_SHIFT (12)
        #define PAGEFMT_FDM_ECC_NUM(x)   (((UINT16)(x) &PAGEFMT_FDM_ECC_MASK) <<PAGEFMT_FDM_ECC_SHIFT)
    
#define NFI_CON       ((volatile UINT32 *)(NFI_BASE_ADDR+0x0008))        
    #define CON_FIFO_FLUSH       (0x0001)  // Flush the data FIFO.
    #define CON_NFI_RST          (0x0002)  // Reset the state machine.    
    #define CON_NFI_SRD          (0x0010)  // It's mainly used for ReadID and Read status, which requires no more than 4 read cycles from the device.
    // NOB: The number of bytes per transaction. If device is 16bits IO or sync/toggle interface, the number will double.    
    #define CON_NFI_NOB_MASK     (0x07)
    #define CON_NFI_NOB_SHIFT    (5)
        #define CON_NOB_BYTE_NUM(x)  (((UINT32)(x) &CON_NFI_NOB_MASK) <<CON_NFI_NOB_SHIFT)
        #define CON_NOB_BYTE         (0x0020)  // 1 byte
        #define CON_NOB_WORD         (0x0040)  // 2 bytes
        #define CON_NOB_DWORD        (0x0080)  // 4 bytes
    #define CON_NFI_BRD          (0x0100)  // Burst read.
    #define CON_NFI_BWR          (0x0200)  // Burst write.
    // SEC_NUM represents the sector number to be retrieved from the device or DMA master. The valid range from 1 to 16.
    #define CON_NFI_SEC_MASK     (0x1F)
    #define CON_NFI_SEC_SHIFT    (12)
        #define CON_NFI_SEC_NUM(x)   (((UINT32)(x) &CON_NFI_SEC_MASK) <<CON_NFI_SEC_SHIFT)
    
#define NFI_ACCCON      ((volatile UINT32 *)(NFI_BASE_ADDR+0x000C))    
#define NFI_INTR_EN     ((volatile UINT16 *)(NFI_BASE_ADDR+0x0010))
    #define INTR_RD_DONE_EN      (0x0001)
    #define INTR_WR_DONE_EN      (0x0002)
    #define INTR_RST_DONE_EN     (0x0004)
    #define INTR_ERASE_DONE_EN   (0x0008)
    #define INTR_BUSY_RTN_EN     (0x0010)  // The busy return
    #define INTR_ACC_LOCK_EN     (0x0020)
    #define INTR_AHB_DONE_EN     (0x0040)    
#define NFI_INTR_STA    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0014))    
    #define INTR_RD_DONE         (0x0001)
    #define INTR_WR_DONE         (0x0002)
    #define INTR_RST_DONE        (0x0004)
    #define INTR_ERASE_DONE      (0x0008)
    #define INTR_BSY_RTN         (0x0010)
    #define INTR_ACC_LOCK        (0x0020)
    #define INTR_AHB_DONE        (0x0040)    
#define NFI_CMD         ((volatile UINT16 *)(NFI_BASE_ADDR+0x0020)) 
	#define NAND_COMMON_PAGE_READ_1ST_CMD      0x00    // if Program  page size 512 nand, must it before Program CMD.
	#define NAND_COMMON_RAGE_READ_2ND_CMD      0x30    // only for greater than or equal to 2K  bytes page-size
	#define NAND_COMMON_RESET_CMD              0xFF

#define NFI_ADDRNOB     ((volatile UINT16 *)(NFI_BASE_ADDR+0x0030))
    // COL_ADDR_NOBL: Number of bytes for the column address    
    #define COL_ADDR_NOB_MASK    (0x07)
    #define COL_ADDR_NOB_SHIFT   (0)
        #define COL_ADDR_NUM(x)   (((UINT16)(x) &COL_ADDR_NOB_MASK) <<COL_ADDR_NOB_SHIFT)
    // ROW_ADDR_NOBL: Number of bytes for the row address    
    #define ROW_ADDR_NOB_MASK    (0x07)
    #define ROW_ADDR_NOB_SHIFT   (4)
        #define ROW_ADDR_NUM(x)   (((UINT16)(x) &ROW_ADDR_NOB_MASK) <<ROW_ADDR_NOB_SHIFT)

#define NFI_COLADDR       ((volatile UINT32 *)(NFI_BASE_ADDR+0x0034))
#define NFI_ROWADDR       ((volatile UINT32 *)(NFI_BASE_ADDR+0x0038))    

// This signal triggers the data transfer for read or write. It only takes effect as custom operation mode.
#define NFI_STRDATA       ((volatile UINT16 *)(NFI_BASE_ADDR+0x0040)) 
    #define STR_DATA                (0x0001)    
#define NFI_CNRNB         ((volatile UINT16 *)(NFI_BASE_ADDR+0x0044))   
    #define CNRNB_STROBE_TIMEOUT    (0x00F1)
#define NFI_DATAW         ((volatile UINT32 *)(NFI_BASE_ADDR+0x0050))
#define NFI_DATAR         ((volatile UINT32 *)(NFI_BASE_ADDR+0x0054))

// Indicates the PIO mode is ready for read data in read mode and ready for write data in write mode. 
// 0: not ready, 1: ready.
#define NFI_PIO_DIRDY     ((volatile UINT32 *)(NFI_BASE_ADDR+0x0058))
    #define GET_PIO_RDY        ((UINT8)((*NFI_PIO_DIRDY) & 0x01))
    #define NFI_PIO_RDY            (0x01)

#define NFI_STA           ((volatile UINT32 *)(NFI_BASE_ADDR+0x0060))
    #define STATUS_CMD                (0x0001)
    #define STATUS_ADDR               (0x0002)
    #define STATUS_DATAR              (0x0004)
    #define STATUS_DATAW              (0x0008)
    #define STATUS_ACC_LOCK           (0x0010)  // The access range is locked for erase or program.
    // Only flash macro is idle, sw reset or nand interface change can be issued.
    #define STATUS_FLASH_MACRO_IDLE   (0x0020)  // 1: idle; 0: non idle
    #define STATUS_BUSY               (0x0100)  // Sync busy signal for the Nand flash.
    #define STATUS_BUSY2READY         (0x0200)  // Nand from busy to ready state.
    #define STATUS_READ_EMPTY_PAGE    (0x1000)  // Empty page flag.
    #define STATUS_NFI_FSM_MASK       (0x000F0000)
    #define STATUS_NAND_FSM_MASK      (0x3F800000)
    #define STATUS_NAND_FSM_TYPE_MASK (0xC0000000)
  
#define NFI_FIFOSTA       ((volatile UINT16 *)(NFI_BASE_ADDR+0x0064))
    #define GET_FIFO_RD_REMAIN    ((UINT8)((*NFI_FIFOSTA) &0x1F))  // FIFO remaining byte number in burst read mode.    
    #define FIFO_RD_EMPTY         (0x0040)
    #define FIFO_RD_FULL          (0x0080)
    #define GET_FIFO_WR_REMAIN    ((UINT8)(((*NFI_FIFOSTA) &0x1F00) >>8))  // FIFO remaining byte number in burst write mode.    
    #define FIFO_WR_EMPTY        (0x4000)
    #define FIFO_WR_FULL         (0x8000)
    
#define NFI_ADDRCNTR      ((volatile UINT32 *)(NFI_BASE_ADDR+0x0070))
    #define GET_SEC_ADDR    ((UINT16)((*NFI_ADDRCNTR) &0x0FFF))  // The address count of main data and spare data for each sector.
    #define GET_SEC_CNTR    ((UINT8)(((*NFI_ADDRCNTR) &0x1F000) >>12))  // The sector count.
    
#define NFI_STRADDR       ((volatile UINT32 *)(NFI_BASE_ADDR+0x0080))
#define NFI_BYTELEN       ((volatile UINT32 *)(NFI_BASE_ADDR+0x0084))
    #define GET_BUS_SEC_ADDR    ((UINT16)((*NFI_BYTELEN) &0x0FFF))  // The address count of main data and spare data for each sector.
    #define GET_BUS_SEC_CNTR    ((UINT8)(((*NFI_BYTELEN) &0x1F000) >>12))  // The sector count.

#define NFI_CSEL          ((volatile UINT16 *)(NFI_BASE_ADDR+0x0090))    
    #define CSEL_CS1                (0x0001)  //Chip select. 0: Device 1, 1: Device 2
   
#define NFI_IOCON       ((volatile UINT16 *)(NFI_BASE_ADDR+0x0094))
  
// NFI Least FDM Data for Sector x, The valid range from 0 to 15.
// Registers Map range from 0x00A0 ~ 0x011C
#define NFI_FDM_L(x)       ((volatile UINT32 *)(NFI_BASE_ADDR+0x00A0+(((x)&0xF) <<3)))  // x*8
#define NFI_FDM_M(x)       ((volatile UINT32 *)(NFI_BASE_ADDR+0x00A4+(((x)&0xF) <<3)))  // x*8

#if 0
#define NFI_CRC01        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0120))
#define NFI_CRC23        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0124))
#define NFI_CRC45        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0128))
#define NFI_CRC67        ((volatile UINT32 *)(NFI_BASE_ADDR+0x012C))
#define NFI_CRC89        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0130))
#define NFI_CRCAB        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0134))
#define NFI_CRCCD        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0138))
#define NFI_CRCEF        ((volatile UINT32 *)(NFI_BASE_ADDR+0x013C)) 
#endif 

#define NFI_FIFODATA0    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0190))
#define NFI_FIFODATA1    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0194))
#define NFI_FIFODATA2    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0198))
#define NFI_FIFODATA3    ((volatile UINT32 *)(NFI_BASE_ADDR+0x019C))

// LCD Monitor be related to registers
#if 0
#define NFI_MCON         ((volatile UINT32 *)(NFI_BASE_ADDR+0x0200))
#define NFI_TOTALCNT     ((volatile UINT32 *)(NFI_BASE_ADDR+0x0204))
#define NFI_RQCNT        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0208))
#define NFI_ACCNT        ((volatile UINT32 *)(NFI_BASE_ADDR+0x020C))
#endif

#define NFI_DEBUG_CON1   ((volatile UINT16 *)(NFI_BASE_ADDR+0x0220))

#define NFI_MASTER_STA   ((volatile UINT16 *)(NFI_BASE_ADDR+0x0224))
#define NFI_MASTER_RST   ((volatile UINT32 *)(NFI_BASE_ADDR+0x0228))
    #define PAD_MACRO_RST    (0x02)

#define NFI_SECCUS_SIZE  ((volatile UINT32 *)(NFI_BASE_ADDR+0x022C))  // Customized size for each sector
    #define CUS_SEC_EN           (1 <<17)
    #define CUS_SEC_SIZE_MASK    (0x1FFF)  // Customized size for each sector.
    #define CUS_SEC_SIZE(x)      ((UINT32)(x) &CUS_SEC_SIZE_MASK)

// SPI be related to registers
#if 0
#define NFI_SPI_ADDRCNTR ((volatile UINT32 *)(NFI_BASE_ADDR+0x0230))
#define NFI_SPI_BYTELEN  ((volatile UINT32 *)(NFI_BASE_ADDR+0x0234))
#endif

// Randomizer be related to registers
#define NFI_RANDOM_CNFG    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0238))
    #define RANDOM_ENC_EN            (0x0001)  // Randomizer encoded enable.
    #define RANDOM_ENC_SEED_MASK     (0x7FFF)  // Randomizer encoded seed.
    #define RANDOM_ENC_SEED_SHIFT    (1)
    #define RANDOM_ENC_SEED(x)       (((UINT16)(x) &RANDOM_ENC_SEED_MASK) <<RANDOM_ENC_SEED_SHIFT)    
    #define RANDOM_DEC_EN            (0x10000)  // Randomizer decoded enable.
    #define RANDOM_DEC_SEED_MASK     (0x7FFF)  // Randomizer decoded seed.
    #define RANDOM_DEC_SEED_SHIFT    (17)
    #define RANDOM_DEC_SEED(x)       (((UINT32)(x) &RANDOM_DEC_SEED_MASK) <<RANDOM_DEC_SEED_SHIFT)
    
#define NFI_EMPTY_THRESH    ((UINT32 *)(NFI_BASE_ADDR+0x023C))
    #define EMPTY_THRESH_MASK     (0xFF)  
    #define EMPTY_THRESH_SHIFT    (0)
    #define EMPTY_THRESH(x)       (((UINT32)(x) &EMPTY_THRESH_MASK) <<EMPTY_THRESH_SHIFT)
    #define GET_ZERO_CNT      ((UINT16)(((*NFI_EMPTY_THRESH) &0xFFFF0000) >>16))

#define NFI_NAND_TYPE_CNFG        ((volatile UINT32 *)(NFI_BASE_ADDR+0x0240))
    #define NAND_INFT_TYPE_ASYNC        (0x00)       
    #define NAND_INFT_TYPE_TOGGLE       (0x01)
    #define NAND_INFT_TYPE_SYNC         (0x02)
    #define NAND_INFT_TYPE_MASK         (0x03)      
    #define NAND_TYPE_SLC               (0x04)

#define NFI_ACCCON1     ((volatile UINT32 *)(NFI_BASE_ADDR+0x0244))
#define NFI_DLYCTRL     ((volatile UINT32 *)(NFI_BASE_ADDR+0x0248))
    #define DLYCTRL_DQS_MODE_MASK                  (0x07)
    #define DLYCTRL_DQS_MODE_SHIFT                 (0)
    #define DLYCTRL_DQS_DLY_SEL_MASK               (0x03F8)
    #define DLYCTRL_DQS_DLY_SEL_SHIFT              (3)
    #define DLYCTRL_DQS_RD_DQS_DDR_TIMING_MASK     (0xF000)
    #define DLYCTRL_DQS_RD_DQS_DDR_TIMING_SHIFT    (12)

// TOSHIBA Randomizer seed registers.
#define NFI_TS_RANDOM_ENC_SEED_0_1    ((volatile UINT32 *)(NFI_BASE_ADDR+0x024C))
#define NFI_TS_RANDOM_ENC_SEED_2      ((volatile UINT32 *)(NFI_BASE_ADDR+0x0250))
#define NFI_TS_RANDOM_ENC_SEED_3      ((volatile UINT32 *)(NFI_BASE_ADDR+0x0254))
#define NFI_TS_RANDOM_ENC_SEED_4_5    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0258))
#define NFI_TS_RANDOM_ENC_SEED_6      ((volatile UINT32 *)(NFI_BASE_ADDR+0x025C))
#define NFI_TS_RANDOM_ENC_SEED_7      ((volatile UINT32 *)(NFI_BASE_ADDR+0x0260))
#define NFI_TS_RANDOM_DEC_SEED_0_1    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0264))
#define NFI_TS_RANDOM_DEC_SEED_2      ((volatile UINT32 *)(NFI_BASE_ADDR+0x0268))
#define NFI_TS_RANDOM_DEC_SEED_3      ((volatile UINT32 *)(NFI_BASE_ADDR+0x026C))
#define NFI_TS_RANDOM_DEC_SEED_4_5    ((volatile UINT32 *)(NFI_BASE_ADDR+0x0270))
#define NFI_TS_RANDOM_DEC_SEED_6      ((volatile UINT32 *)(NFI_BASE_ADDR+0x0274))
#define NFI_TS_RANDOM_DEC_SEED_7      ((volatile UINT32 *)(NFI_BASE_ADDR+0x0278))
    
// DQS delay control. [17:16]- DQS_dly_mux, [14:10]- DQS_dly2_sel, [9:5]- DQS_dly1_sel, [4:0]- DQS_dly0_sel
#define NFI_MAC_CTRL      ((volatile UINT32 *)(NFI_BASE_ADDR+0x027C))

/*******************************************************************************
 * Nand Flash common command definition
 *******************************************************************************/
#define NAND_COMMON_PAGE_READ_1ST_CMD      0x00    // if Program  page size 512 nand, must it before Program CMD.
#define NAND_COMMON_PAGE_PROG_CNF_CMD      0x10    // program confirm command
#define NAND_COMMON_RAGE_READ_2ND_CMD      0x30    // only for greater than or equal to 2K  bytes page-size
#define NAND_COMMON_COPYBACK_READ_CMD      0x35    // only for greater than or equal to 2K  bytes page-size
#define NAND_COMMON_BLOCK_ERASE_1ST_CMD    0x60
#define NAND_COMMON_READ_STATUS_CMD        0x70
#define NAND_COMMON_PAGE_PROGRAM_CMD       0x80
#define NAND_COMMON_COPYBACK_PROGRAM_CMD   0x85
#define NAND_COMMON_READID_CMD             0x90
#define NAND_COMMON_BLOCK_ERASE_2ND_CMD    0xD0
#define NAND_COMMON_GET_FEATURES_ACMD      0xEE
#define NAND_COMMON_SET_FEATURES_ACMD      0xEF
#define NAND_COMMON_RESET_CMD              0xFF

// Serial nand flash be related to registers
// Registers address range from 0x0500 ~ 0x0560

#define FDM_BYTES  8
#define FDM_ECC_BYTES 8
#define MTD_NAND_DEFAULT_TIMEOUT	0x0002FFFF
#define NFI_SECTOR_SIZE_512    (512)
#define NFI_SECTOR_SIZE_1K     (1024)

#define NFI_Wait_Ready(timeout)   while ( (*NFI_STA  & STATUS_BUSY) && (timeout--) )

/* FLASH OPERATION STATUS */
typedef enum {
	 S_DONE = 0
	,S_PGM_FAILED
	,S_ERASE_FAILED
	,S_TIMEOUT
	,S_IN_PROGRESS
	,S_CMD_ERR
	,S_BLOCK_LOCKED_ERR
	,S_BLOCK_UNSTABLE
	,S_VPP_RANGE_ERR
	,S_INVALID_BEGIN_ADDR
	,S_INVALID_RANGE
	,S_PGM_AT_ODD_ADDR
	,S_PGM_WITH_ODD_LENGTH
	,S_BUFPGM_NO_SUPPORT
	,S_UNKNOWN_ERR
	,S_BAD_BLOCK
	,S_ECC_1BIT_CORRECT
	,S_ECC_2BITS_ERR
	,S_ECC_UNCORRECT_ERR
	,S_ECC_CORRECTABLE_ERR
	,S_SPARE_CHKSUM_ERR
	,S_HW_COPYBACK_ERR
	,S_INVALID_PAGE_INDEX
	,S_NFI_NOT_SUPPORT
	,S_NFI_CS1_NOT_SUPPORT
	,S_NFI_16BITS_IO_NOT_SUPPORT
	,S_NO_GOOD_BLOCK_FOUND
	,S_SETUP_PLL_ERR
	,S_MOBILE_RAM_NOT_SUPPORT
	,S_RAM_FLOARTING
	,S_RAM_UNACCESSABLE
	,S_RAM_ERROR
	,S_DEVICE_NOT_FOUND
	,S_REACH_END_ADDR
	,S_BLOADER_IS_TOO_LARGE
	,S_SIBLEY_REWRITE_OBJ_MODE_REGION
	,S_SIBLEY_WRITE_B_HALF_IN_CTRL_MODE_REGION
	,S_SIBLEY_ILLEGAL_CMD
	,S_SIBLEY_PGM_AT_THE_SAME_REGIONS
	,S_CREATE_SEMAPHORE_FAIL
	,S_DEL_SEMAPHORE_FAIL
	,S_CREATE_EVENT_FAIL
  ,S_DEL_EVENT_FAIL	
	,S_REG_ISR_FAIL
	,S_UNREG_ISR_FAIL	
	,STATUS_END
} STATUS_E;

#define NFI_Wait(condition_expression, timeout)		while( (condition_expression) && (--timeout) )

#define NFI_EVENT_NAME 		"NFI_EVENT"

#ifdef _XOS_ISR_ENABLE_
extern HANDLE_T _hNFIEvent;
extern HANDLE_T _hNFISema;
#endif //_XOS_ISR_ENABLE

#endif //_NFI_H
