U_BOOT_DIR             := $(shell pwd)
GENERIC_DIR := $(word 1, $(subst /BDP_Linux/,/BDP_Generic /, $(shell pwd)))
LINUX_DIR := $(word 1, $(subst /BDP_Linux/,/BDP_Linux /, $(shell pwd)))
.PHONY: all

all:

	@source ../../../../../BDP_Generic/setenv.sh && source ./link.sh
	@if [ "`grep mt8530_base_config ./link.sh`" != "" ]; then \
	    echo "mt8530_base_config has been configed"; \
	else \
	    echo "mt8530_base_config has not been configed then config it"; \
	    make -j ${JOBS} -C ${U_BOOT_DIR} mt8530_base_config O=../../../build/u-boot/u-boot-2009.08 && echo "#mt8530_base_config success" >> link.sh; \
	fi
	@echo "<UBOOT>to build normal uboot"
	make -C ${U_BOOT_DIR} clean O=../../../build/u-boot/u-boot-2009.08
	sed -i 's/#define CONFIG_BL_WITH_UART_OFF.*/#define CONFIG_BL_WITH_UART_OFF 0/' ${LINUX_DIR}/oss/source/u-boot/current_build/include/chip_ver.h
	make -j ${JOBS} -C ${U_BOOT_DIR} O=../../../build/u-boot/u-boot-2009.08
	cp -f ../../../build/u-boot/u-boot-2009.08/u-boot.bin ../../../../res/u-boot-8530.bin
	@echo "<UBOOT>debug uboot built done"
	@if [ "`grep bl_uart_disable ${GENERIC_DIR}/build/configuration`" != "" ]; then \
		echo "<UBOOT>bl_uart_disable is set, so first to build secure u-boot"; \
		make -C ${U_BOOT_DIR} clean O=../../../build/u-boot/u-boot-2009.08; \
		sed -i 's/#define CONFIG_BL_WITH_UART_OFF.*/#define CONFIG_BL_WITH_UART_OFF 1/' ${LINUX_DIR}/oss/source/u-boot/current_build/include/chip_ver.h; \
		make -j ${JOBS} -C ${U_BOOT_DIR} O=../../../build/u-boot/u-boot-2009.08; \
		cp -f ../../../build/u-boot/u-boot-2009.08/u-boot.bin ../../../../res/u-boot-8530-secure.bin; \
		echo "<UBOOT>secure uboot built done"; \
	fi
